<?php
// $Id: carto.inc,v 1.11.2.1 2006/04/07 11:19:01 openwereld Exp $

/**
 * These are the functions to be defined only when module is enabled.
 * Otherwise they could mess up with the admin system
 */

$value = variable_get('carto_smarty_dir','');
if( file_exists( $value . 'Smarty.class.php' ) )
{
    define( "SMARTY_DIR", $value );
}
else if( is_dir( dirname(__FILE__) . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR . 'smarty' . DIRECTORY_SEPARATOR ) )
{
    // smarty installed under carto module
    define( "SMARTY_DIR", dirname(__FILE__) . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR . 'smarty' . DIRECTORY_SEPARATOR );
}
else
{
    // default
    define( 'SMARTY_DIR', '/usr/share/php/smarty/libs/' );
}

$value = variable_get('carto_mappingwidgets_dir','');
if( file_exists( $value . 'MappingWidgets.php' ) )
{
    define( "MAPPINGWIDGETS_DIR", $value );
}
else if( is_dir( dirname(__FILE__) . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR . 'mappingwidgets' . DIRECTORY_SEPARATOR ) )
{
    // mappingwidgets installed under carto module
    define( "MAPPINGWIDGETS_DIR", dirname(__FILE__) . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR . 'mappingwidgets' . DIRECTORY_SEPARATOR );
}
else
{
    // default
    define( "MAPPINGWIDGETS_DIR", "/usr/local/share/mappingwidgets/" );
}

$value = variable_get('carto_mappingwidgets_base_uri','');
if( $value != '' )
{
    define( "MAPPINGWIDGETS_BASE_URI", $value );
}
else
{
    define( 'MAPPINGWIDGETS_BASE_URI', '/mappingwidgets/' );
}

if( file_exists(variable_get('carto_mappingwidgets_dir',MAPPINGWIDGETS_DIR) . 'MappingWidgets.php') 
 && file_exists(variable_get('carto_smarty_dir',SMARTY_DIR) . 'Smarty.class.php' ) )
{
    require( variable_get('carto_mappingwidgets_dir',MAPPINGWIDGETS_DIR) . 'MappingWidgets.php' );
    
    class CartoMapper extends SmartyMapping
    {
        function CartoMapper( )
        {
            // use current drupal locale
            global $locale;
            
            $this->SmartyMapping( $locale );
            
            $this->caching = true;
            $this->caching = false;
/*
            print 'carto info | locale=' . $locale 
                . ' | path=' . drupal_get_path_alias($_GET['q'])
                . ' | caching=' . $this->caching
                . '<br />';
*/
            $this->set_html_head( );
            
            // register the resource name "carto"
            $this->register_resource( "carto"
                , array( "carto_get_template",
                         "carto_get_timestamp",
                         "carto_get_secure",
                         "carto_get_trusted" ) );
        }
        
        function set_html_head( )
        {
            return drupal_set_html_head(
                "\n<style type=\"text/css\">@import url("
                . variable_get('carto_mappingwidgets_base_uri',MAPPINGWIDGETS_BASE_URI) . 'skins/default/styles/mappingwidgets.css'
                . ");</style>\n<style type=\"text/css\">@import url(" 
                . drupal_get_path('module','carto') . "/carto.css);</style>\n"
                . "<meta http-equiv=\"imagetoolbar\" content=\"no\" />\n"
                );
        }
    
    }
    
    function get_carto_mapper( )
    {
        if( ! isset( $GLOBALS['cartoSmarty'] ) )
        {
            $GLOBALS['cartoSmarty'] = & new CartoMapper();
        }
        return $GLOBALS['cartoSmarty'];
    }
}

function carto_get_template( $tpl_name, &$tpl_source, &$smarty_obj )
{
    // do database call here to fetch your template,
    // populating $tpl_source
    $sql = "select content from {carto_filter_blocks} where cfid = '%s'";
    $result = db_query( $sql, $tpl_name );
    if( db_num_rows( $result ) > 0 )
    {
        $item = db_fetch_object( $result );
        $tpl_source = $item->content;
        return true;
    }
    else
    {
        return false;
    }
}

function carto_get_timestamp( $tpl_name, &$tpl_timestamp, &$smarty_obj )
{
    // do database call here to populate $tpl_timestamp.
    $sql = "select time from {carto_filter_blocks} where cfid = '%s'";
    $result = db_query( $sql, $tpl_name );
    if( db_num_rows( $result ) > 0 )
    {
        $item = db_fetch_object( $result );
        $tpl_timestamp = $item->time;
        return true;
    }
    else
    {
        return false;
    }
}


function carto_get_secure( $tpl_name, &$smarty_obj )
{
    // assume all templates are secure
    return true;
}


function carto_get_trusted( $tpl_name, &$smarty_obj )
{
    // not used for templates
}

?>
